// -*- C++ -*-

/* 
 * Gnome Crystal
 * prefs.h 
 *
 * Copyright (C) 2001-2003
 *
 * Developed by Jean Brfort <jean.brefort@ac-dijon.fr>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GCRYSTAL_PREFS_H
#define GCRYSTAL_PREFS_H

#include "dialog.h"


class gcPrefsDlg: public gcDialog
{
public:
	gcPrefsDlg();
	virtual ~gcPrefsDlg();

	virtual bool Apply();
	void PrintResolutionSelect(GtkWidget* widget);
	void TabPositionSelect(GtkWidget* widget);

private:
	void UpdatePrinting();

private:
	GtkOptionMenu *TabsMenu, *PrintResMenu;
	GtkSpinButton *PrintResBtn;
	GnomeColorPicker *BackgroundBtn;
	GtkSpinButton *FoVBtn;
	GtkEntry *PsiEnt, *ThetaEnt, *PhiEnt;
	guint m_nTabPos, m_nPrintRes, m_nPrintIndex;
};

#endif //GCRYSTAL_PREFS_H
